#ifndef _CPU
#define _CPU
 
#include "Port.h"

class cpu 
{
  public:
  // Data register
  // Control register0x10ZAhX
    static const unsigned int port1 = 0xFFD4;
    static const unsigned int port2 = 0xFFD5;
    static const unsigned int port3 = 0xFFD6;
    static const unsigned int port5 = 0xFFD8;
    static const unsigned int port6 = 0xFFD9;
    static const unsigned int port7 = 0xFFDA;
    static const unsigned int port8 = 0xFFDB;
    static const unsigned int portB = 0xFFDD;
    
    static const int SHIFT_MSB = -1;
    static const int SHIFT_LSB = -2;
    static const int PRE_CLOCK_MSB = 0;
    static const int POST_CLOCK_MSB = 1;
    static const int PRE_CLOCK_LSB = 2;
    static const int POST_CLOCK_LSB = 3;
    
    static unsigned char PCR2;
    static unsigned char PCR5;
    static unsigned char PCR6;
    static unsigned char PCR7;
    static unsigned char PCR8;

    static unsigned char BZR_PITCH;
    static unsigned char BZR_VOL;
    
/*   
    

    static int rcTime(int timeout, int port, int bit, bool state);
*/
    cpu();
    static void delay(unsigned wait);
    static void pulseOut(unsigned length, unsigned port, int bit);
    static void pulseOut(unsigned length, Port& port);
    static int pulseIn(unsigned timeout, unsigned port, int bit, bool pinState);
    static unsigned char readPin(unsigned int port, int bit);
    static unsigned char readPin(Port& P);
    static void setInput(unsigned int port);
    static void setInput(unsigned int port, int bit);
    static void setInput(Port& P);
    static void setIOPort(unsigned int port, int value);
    static void writePin(unsigned int port, int bit, bool value);
    static void writePin(Port& P, bool value);
    static void writePort(unsigned int port, unsigned char value);
    static void writePort(Port& value);
    static void shiftOut(unsigned dataPort, int dPin, unsigned clockPort, int cPin, int bitCount, int mode, unsigned short data);
    static void shiftOut(Port& dPin, Port& cPin, int bitCount, int mode, unsigned short data);
    static int shiftIn(unsigned dataPort, int dPin, unsigned clockPort, int cPin, int bitCount, int mode); 
    static int shiftIn(Port& dPin, Port& cPin, int bitCount, int mode);
    static void setOutput(unsigned int port, unsigned char bit);
    static void setOutput(unsigned int port);
    static void setOutput(Port& P);
    static void setOutputPort(unsigned int port, int value);
    static int readPort(unsigned int port);
    static void setChipEnable(unsigned char);
    
    static void BuzzerSet(unsigned char pitch , unsigned char vol);
    static void BuzzerStart();
    static void BuzzerStop();

} ;

#endif